function[zdotsol, Sdotsol] = HankelsquareLoss_dual_get_zdotSdot(U, Udot, C, y, z, S, UtS, options, L, zdotinit, Sdotinit)
    [d, r] = size(U);
    T = length(y) + 1 - d;
    
    if ~exist('zdotinit', 'var') || ~exist ('Sdotinit','var')
        zdotinit = zeros(d + T - 1, 1);
        Sdotinit = zeros(d, T);
    end
    %     % We solve the following system using pcg.
    %     myproj(zdot/2C, UUt Sdot  + reg Sdot) = -myproj(0, (UdotUt + UUdott)S).
    
    UdottS = Udot'*S;
    
    rhs.z = zeros(size(z));
    rhs.S = Udot*(UtS) + U*UdottS;
    rhs = myproj(rhs, options);
    RHS = -[rhs.z; rhs.S(:)]; % - proj
    
    % Call PCG
    tol_omegax_pcg = options.innerpcgdottol; %
    max_iterations_pcg = options.innerpcgdotmaxiter;%
    
    %     % With matrix preconditioner
    %     if ~exist('L','var') || isempty(L)
    %         M = (eye(d + T -1 + d*T))/(2*C);
    %         M(d + T:end, d+T:end) = kron(eye(T), U*U' + 1e-5*eye(d));
    %         M = sparse(M);
    %         L = ichol(M);
    %     end
    %     [zdotSdotsol, unused, relres, iter] = pcg(@compute_dotmatrix_system, RHS, tol_omegax_pcg, max_iterations_pcg,L,L',[zdotinit; Sdotinit(:)]);
    
    
    % With precon function handle
    if ~exist('L','var') || isempty(L)
        UtU = U'*U;
        L = (eye(r)  + (UtU)/options.preconreg);
    end
    [zdotSdotsol, unuseddot, relresdot, iterdot] = pcg(@compute_dotmatrix_system, RHS, tol_omegax_pcg, max_iterations_pcg, @myprecon,[],[zdotinit;  Sdotinit(:)]);
    
    
    %     % Without preconditioner
    %     [zdotSdotsol, unused, relres, iter] = pcg(@compute_dotmatrix_system, RHS, tol_omegax_pcg, max_iterations_pcg,[],[],[zdotinit;  Sdotinit(:)]);
    
    function LHSx = compute_dotmatrix_system(zdotSdotx)
        zdotx = zdotSdotx(1 : d + T - 1);
        Sdotx = reshape(zdotSdotx(d + T : end), d, T);
        
        %         x.z = zdotx;
        %         x.S = Sdotx;
        %         x = myproj(x, options);
        %         zdotx = x.z;
        %         Sdotx = x.S;
        
        UtSdotx = U'*Sdotx;
        
        lhs.z = zdotx/(2*C);
        lhs.S = U*UtSdotx + options.reg*Sdotx;
        lhs = myproj(lhs, options);
        LHSx = [lhs.z; lhs.S(:)];
        
        %         % Sanity checks.
        %         disp(norm(LHSx - RHS, 'fro')/norm(RHS, 'fro'));
    end
    
    function PzSx = myprecon(zSx)
        zx = zSx(1 : d + T - 1);
        Sx = reshape(zSx(d + T : end), d, T);
        
        %         % Sanity check.
        %         x.z = zx;
        %         x.S = Sx;
        %         x1 = myproj(x, options);
        %         sqrt(norm(x1.z - x.z)^2 + norm(x1.S - x.S, 'fro')^2)
        
        Pzx = (2*C)*zx;
        PSx =  (Sx - U*((options.preconreg*L)\(U'*Sx)))/(options.preconreg);  
        
        %         % Check
        %         UUt = U*U';
        %         PSx1 = (UUt +(options.preconreg)*eye(d))\Sx;
        %         norm(PSx - PSx1, 'fro')
        
        Px.z = Pzx;
        Px.S = PSx;
        Px = myproj(Px, options);
        %         norm(Px.z - Px1.z)
        PzSx = [Px.z; Px.S(:)];
    end
    
    zdotsol = zdotSdotsol(1 : d + T -1);
    Sdotsol = reshape(zdotSdotsol(d + T : end), d, T);
    
    xsol.z = zdotsol;
    xsol.S = Sdotsol;
    xsol = myproj(xsol, options);
    zdotsol = xsol.z;
    Sdotsol = xsol.S;
    
    %     % Sanity checks.
    %     sdotsol = Sdotsol(:);
    %     Hsdotsol = zeros(size(zdotsol));
    %     for t = 1:(d+T-1)
    %         [I, J] = getindices(t+1, d, T);
    %         idx_t = sub2ind([d T], I, J);
    %         Hsdotsol(t) = sum(sdotsol(idx_t));
    %     end
    %     norm(-Hsdotsol + zdotsol, 'fro') % This should be zero.
    
end